<template>
  <b-navbar data-cy="navbar" toggleable="md" type="dark" class="jh-navbar">
    <b-navbar-brand class="logo" b-link to="/">
      <span class="logo-img"></span>
      <span v-text="$t('global.title')" class="navbar-title">gateway</span> <span class="navbar-version">{{ version }}</span>
    </b-navbar-brand>
    <b-navbar-toggle
      right
      class="jh-navbar-toggler d-lg-none"
      href="javascript:void(0);"
      data-toggle="collapse"
      target="header-tabs"
      aria-expanded="false"
      aria-label="Toggle navigation"
    >
      <font-awesome-icon icon="bars" />
    </b-navbar-toggle>

    <b-collapse is-nav id="header-tabs">
      <b-navbar-nav class="ml-auto">
        <b-nav-item to="/" exact>
          <span>
            <font-awesome-icon icon="home" />
            <span v-text="$t('global.menu.home')">Home</span>
          </span>
        </b-nav-item>
        <b-nav-item-dropdown right id="entity-menu" v-if="authenticated" active-class="active" class="pointer" data-cy="entity">
          <span slot="button-content" class="navbar-dropdown-menu">
            <font-awesome-icon icon="th-list" />
            <span class="no-bold" v-text="$t('global.menu.entities.main')">Entities</span>
          </span>
          <b-dropdown-item to="/adherencia">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.pacientesAdherencia')">Adherencia</span>
          </b-dropdown-item>
          <b-dropdown-item to="/agenda">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.pacientesAgenda')">Agenda</span>
          </b-dropdown-item>
          <b-dropdown-item to="/alarma">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.pacientesAlarma')">Alarma</span>
          </b-dropdown-item>
          <b-dropdown-item to="/biologico">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.biologicoBiologico')">Biologico</span>
          </b-dropdown-item>
          <b-dropdown-item to="/caloria">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.manillaCaloria')">Caloria</span>
          </b-dropdown-item>
          <b-dropdown-item to="/ciclo-actividad">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.biologicoCicloActividad')">Ciclo Actividad</span>
          </b-dropdown-item>
          <b-dropdown-item to="/ciudad">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.pacientesCiudad')">Ciudad</span>
          </b-dropdown-item>
          <b-dropdown-item to="/condicion">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.pacientesCondicion')">Condicion</span>
          </b-dropdown-item>
          <b-dropdown-item to="/cuestionario-estado">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.pacientesCuestionarioEstado')">Cuestionario Estado</span>
          </b-dropdown-item>
          <b-dropdown-item to="/dispositivo">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.manillaDispositivo')">Dispositivo</span>
          </b-dropdown-item>
          <b-dropdown-item to="/encuesta">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.manillaEncuesta')">Encuesta</span>
          </b-dropdown-item>
          <b-dropdown-item to="/espirometria">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.expedientemanualEspirometria')">Espirometria</span>
          </b-dropdown-item>
          <b-dropdown-item to="/fabricante">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.biologicoFabricante')">Fabricante</span>
          </b-dropdown-item>
          <b-dropdown-item to="/farmaceutica">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.pacientesFarmaceutica')">Farmaceutica</span>
          </b-dropdown-item>
          <b-dropdown-item to="/fisiometria-1">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.manillaFisiometria1')">Fisiometria 1</span>
          </b-dropdown-item>
          <b-dropdown-item to="/fisiometria-2">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.diademaFisiometria2')">Fisiometria 2</span>
          </b-dropdown-item>
          <b-dropdown-item to="/frecuencia-cardiaca">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.manillaFrecuenciaCardiaca')">Frecuencia Cardiaca</span>
          </b-dropdown-item>
          <b-dropdown-item to="/glucosa">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.expedientemanualGlucosa')">Glucosa</span>
          </b-dropdown-item>
          <b-dropdown-item to="/historial-actividad">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.biologicoHistorialActividad')">Historial Actividad</span>
          </b-dropdown-item>
          <b-dropdown-item to="/ingesta">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.manillaIngesta')">Ingesta</span>
          </b-dropdown-item>
          <b-dropdown-item to="/ips">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.pacientesIps')">IPS</span>
          </b-dropdown-item>
          <b-dropdown-item to="/medicamento">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.pacientesMedicamento')">Medicamento</span>
          </b-dropdown-item>
          <b-dropdown-item to="/notificacion">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.manillaNotificacion')">Notificacion</span>
          </b-dropdown-item>
          <b-dropdown-item to="/oximetria">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.manillaOximetria')">Oximetria</span>
          </b-dropdown-item>
          <b-dropdown-item to="/paciente">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.pacientesPaciente')">Paciente</span>
          </b-dropdown-item>
          <b-dropdown-item to="/pais">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.pacientesPais')">Pais</span>
          </b-dropdown-item>
          <b-dropdown-item to="/pasos">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.manillaPasos')">Pasos</span>
          </b-dropdown-item>
          <b-dropdown-item to="/peso">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.expedientemanualPeso')">Peso</span>
          </b-dropdown-item>
          <b-dropdown-item to="/pregunta">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.pacientesPregunta')">Pregunta</span>
          </b-dropdown-item>
          <b-dropdown-item to="/presion-sanguinea">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.manillaPresionSanguinea')">Presion Sanguinea</span>
          </b-dropdown-item>
          <b-dropdown-item to="/programa">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.manillaPrograma')">Programa</span>
          </b-dropdown-item>
          <b-dropdown-item to="/sueno">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.manillaSueno')">Sueno</span>
          </b-dropdown-item>
          <b-dropdown-item to="/temperatura">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.manillaTemperatura')">Temperatura</span>
          </b-dropdown-item>
          <b-dropdown-item to="/token-disp">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.manillaTokenDisp')">Token Disp</span>
          </b-dropdown-item>
          <b-dropdown-item to="/tratamiento">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.pacientesTratamiento')">Tratamiento</span>
          </b-dropdown-item>
          <b-dropdown-item to="/tratamiento-medicamento">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.pacientesTratamientoMedicamento')">Tratamiento Medicamento</span>
          </b-dropdown-item>
          <b-dropdown-item to="/vacuna">
            <font-awesome-icon icon="asterisk" />
            <span v-text="$t('global.menu.entities.biologicoVacuna')">Vacuna</span>
          </b-dropdown-item>
          <!-- jhipster-needle-add-entity-to-menu - JHipster will add entities to the menu here -->
        </b-nav-item-dropdown>
        <b-nav-item-dropdown
          right
          id="admin-menu"
          v-if="hasAnyAuthority('ROLE_ADMIN') && authenticated"
          :class="{ 'router-link-active': subIsActive('/admin') }"
          active-class="active"
          class="pointer"
          data-cy="adminMenu"
        >
          <span slot="button-content" class="navbar-dropdown-menu">
            <font-awesome-icon icon="users-cog" />
            <span class="no-bold" v-text="$t('global.menu.admin.main')">Administration</span>
          </span>
          <b-dropdown-item to="/admin/gateway" active-class="active">
            <font-awesome-icon icon="road" />
            <span v-text="$t('global.menu.admin.gateway')">Gateway</span>
          </b-dropdown-item>
          <b-dropdown-item to="/admin/metrics" active-class="active">
            <font-awesome-icon icon="tachometer-alt" />
            <span v-text="$t('global.menu.admin.metrics')">Metrics</span>
          </b-dropdown-item>
          <b-dropdown-item to="/admin/health" active-class="active">
            <font-awesome-icon icon="heart" />
            <span v-text="$t('global.menu.admin.health')">Health</span>
          </b-dropdown-item>
          <b-dropdown-item to="/admin/configuration" active-class="active">
            <font-awesome-icon icon="cogs" />
            <span v-text="$t('global.menu.admin.configuration')">Configuration</span>
          </b-dropdown-item>
          <b-dropdown-item to="/admin/logs" active-class="active">
            <font-awesome-icon icon="tasks" />
            <span v-text="$t('global.menu.admin.logs')">Logs</span>
          </b-dropdown-item>
          <b-dropdown-item v-if="openAPIEnabled" to="/admin/docs" active-class="active">
            <font-awesome-icon icon="book" />
            <span v-text="$t('global.menu.admin.apidocs')">API</span>
          </b-dropdown-item>
          <b-dropdown-item v-if="!inProduction" href="http://localhost:8092/" target="_tab">
            <font-awesome-icon icon="database" />
            <span v-text="$t('global.menu.admin.database')">Database</span>
          </b-dropdown-item>
        </b-nav-item-dropdown>
        <b-nav-item-dropdown id="languagesnavBarDropdown" right v-if="languages && Object.keys(languages).length > 1">
          <span slot="button-content">
            <font-awesome-icon icon="flag" />
            <span class="no-bold" v-text="$t('global.menu.language')">Language</span>
          </span>
          <b-dropdown-item
            v-for="(value, key) in languages"
            :key="`lang-${key}`"
            v-on:click="changeLanguage(key)"
            :class="{ active: isActiveLanguage(key) }"
          >
            {{ value.name }}
          </b-dropdown-item>
        </b-nav-item-dropdown>
        <b-nav-item-dropdown
          right
          href="javascript:void(0);"
          id="account-menu"
          :class="{ 'router-link-active': subIsActive('/account') }"
          active-class="active"
          class="pointer"
          data-cy="accountMenu"
        >
          <span slot="button-content" class="navbar-dropdown-menu">
            <font-awesome-icon icon="user" />
            <span class="no-bold" v-text="$t('global.menu.account.main')"> Account </span>
          </span>
          <b-dropdown-item data-cy="logout" v-if="authenticated" v-on:click="logout()" id="logout" active-class="active">
            <font-awesome-icon icon="sign-out-alt" />
            <span v-text="$t('global.menu.account.logout')">Sign out</span>
          </b-dropdown-item>
          <b-dropdown-item data-cy="login" v-if="!authenticated" v-on:click="openLogin()" id="login" active-class="active">
            <font-awesome-icon icon="sign-in-alt" />
            <span v-text="$t('global.menu.account.login')">Sign in</span>
          </b-dropdown-item>
        </b-nav-item-dropdown>
      </b-navbar-nav>
    </b-collapse>
  </b-navbar>
</template>

<script lang="ts" src="./jhi-navbar.component.ts"></script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
/* ==========================================================================
    Navbar
    ========================================================================== */
.navbar-version {
  font-size: 10px;
  color: #ccc;
}

.jh-navbar {
  background-color: #353d47;
  padding: 0.2em 1em;
}

.jh-navbar .profile-image {
  margin: -10px 0px;
  height: 40px;
  width: 40px;
  border-radius: 50%;
}

.jh-navbar .dropdown-item.active,
.jh-navbar .dropdown-item.active:focus,
.jh-navbar .dropdown-item.active:hover {
  background-color: #353d47;
}

.jh-navbar .dropdown-toggle::after {
  margin-left: 0.15em;
}

.jh-navbar ul.navbar-nav {
  padding: 0.5em;
}

.jh-navbar .navbar-nav .nav-item {
  margin-left: 1.5rem;
}

.jh-navbar a.nav-link,
.jh-navbar .no-bold {
  font-weight: 400;
}

.jh-navbar .jh-navbar-toggler {
  color: #ccc;
  font-size: 1.5em;
  padding: 10px;
}

.jh-navbar .jh-navbar-toggler:hover {
  color: #fff;
}

@media screen and (min-width: 768px) {
  .jh-navbar-toggler {
    display: none;
  }
}

@media screen and (min-width: 768px) and (max-width: 1150px) {
  span span {
    display: none;
  }
}

.navbar-title {
  display: inline-block;
  vertical-align: middle;
  color: white;
}

/* ==========================================================================
    Logo styles
    ========================================================================== */
.navbar-brand.logo {
  padding: 5px 15px;
}

.logo .logo-img {
  height: 45px;
  display: inline-block;
  vertical-align: middle;
  width: 70px;
}

.logo-img {
  height: 100%;
  background: url('../../../content/images/logo-jhipster.png') no-repeat center center;
  background-size: contain;
  width: 100%;
  filter: drop-shadow(0 0 0.05rem white);
}
</style>
